VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Brain washer - logical game"
   ClientHeight    =   4815
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   8625
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   321
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   575
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox List3 
      Height          =   4545
      ItemData        =   "Konj.frx":0000
      Left            =   8040
      List            =   "Konj.frx":0002
      TabIndex        =   3
      Top             =   120
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.ListBox List2 
      Height          =   2205
      ItemData        =   "Konj.frx":0004
      Left            =   7560
      List            =   "Konj.frx":0006
      TabIndex        =   2
      Top             =   0
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.ListBox List1 
      Height          =   2205
      ItemData        =   "Konj.frx":0008
      Left            =   7200
      List            =   "Konj.frx":000A
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   540
      Left            =   5400
      Picture         =   "Konj.frx":000C
      Stretch         =   -1  'True
      Top             =   4080
      Visible         =   0   'False
      Width           =   540
   End
   Begin VB.Label Label1 
      BackColor       =   &H000000FF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label1"
      Height          =   540
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   540
   End
   Begin VB.Menu Level 
      Caption         =   "Level"
      Begin VB.Menu Beginer 
         Caption         =   "Beginer"
      End
      Begin VB.Menu Intermediate 
         Caption         =   "Intermediate"
      End
      Begin VB.Menu Expert 
         Caption         =   "Expert"
      End
      Begin VB.Menu Prodigy 
         Caption         =   "Prodigy"
      End
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
   End
   Begin VB.Menu About 
      Caption         =   "About"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim MemTop, MemLeft As Integer
Dim FirstClick As Boolean
Dim Hdim1 As Integer
Dim Wdim1 As Integer


Private Sub About_Click()
MsgBox "Comments to: kozlicki@yahoo.com"
End Sub

Private Sub Beginer_Click()
 
Me.WindowState = 0
Image1.Width = 36
Image1.Height = 36

Label1(0).Width = 36
Label1(0).Height = 36
Call Mix(4, 4)


End Sub



Private Sub Command1_Click()
Call Mix(Hdim1, Wdim1)

End Sub

Private Sub Undo()
    If List3.ListCount = 0 Then Exit Sub
    If List3.ListCount = 1 Then ' no more undos
        'current back to blue color
        Label1(List3.List(List3.ListCount - 1)).BackColor = QBColor(9)
        Image1.Visible = False
        FirstClick = False
        List3.Clear
        Exit Sub
    End If
    
    'current back to blue color
    Label1(List3.List(List3.ListCount - 1)).BackColor = QBColor(9)
     
    'move one back
    Image1.Top = Label1(List3.List(List3.ListCount - 2)).Top
    Image1.Left = Label1(List3.List(List3.ListCount - 2)).Left
    'reset globals
    MemTop = Label1(List3.List(List3.ListCount - 2)).Top
    MemLeft = Label1(List3.List(List3.ListCount - 2)).Left
    FirstClick = True
    'get picture over clicked label
    
    '& change it's color to....
    Label1(Index).BackColor = QBColor(0) 'black
    'remember position
    'for use with redo and undo
    List3.RemoveItem (List3.ListCount - 1)
End Sub

Private Sub Expert_Click()
 
Me.WindowState = 0
Image1.Width = 36
Image1.Height = 36

Label1(0).Width = 36
Label1(0).Height = 36
Call Mix(16, 8)

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Select Case KeyCode
Case vbKeyR
  Mix Hdim1, Wdim1
Case vbKeyU
  Undo
Case Else
End Select

End Sub


Private Sub Help_Click()
MsgBox "The task is simple - turn all blue fields to black by clicking them. Each field can be clicked only once. Follow the chess rules for figure displayed." & Chr(13) & _
"For undo press U, for remix press R" & Chr(13) & _
"Have fun !"
End Sub

Private Sub Intermediate_Click()
 
Me.WindowState = 0
Image1.Width = 36
Image1.Height = 36

Label1(0).Width = 36
Label1(0).Height = 36
Call Mix(8, 8)

  End Sub

Private Sub Label1_Click(Index As Integer)
If FirstClick = True Or Label1(Index).BackColor = &HFF& Then GoTo 9 ' firs click has already happened
    'intercept first click &
    ' get pos into global variable
    MemTop = Label1(Index).Top
    MemLeft = Label1(Index).Left
    FirstClick = True
    'get picture over clicked label
    Image1.Visible = True
    Image1.Top = Label1(Index).Top
    Image1.Left = Label1(Index).Left
    '& change it's color to....
    Label1(Index).BackColor = QBColor(0) 'black
    'remember position
    'for use with redo and undo
    List3.AddItem (Index)
9

If Label1(Index).BackColor = &HFF& Or Label1(Index).BackColor = QBColor(0) Then  '' red or black color
Beep ' do nothing as it is not applayed to rulls
Else
  If ((Label1(Index).Left = MemLeft + (Label1(Index).Width * 2)) And (Label1(Index).Top = MemTop + (Label1(Index).Height))) Or _
     ((Label1(Index).Left = MemLeft + (Label1(Index).Width)) And (Label1(Index).Top = MemTop + (Label1(Index).Height * 2))) Or _
     ((Label1(Index).Left = MemLeft + (Label1(Index).Width * 2)) And (Label1(Index).Top = MemTop - (Label1(Index).Height))) Or _
     ((Label1(Index).Left = MemLeft + (Label1(Index).Width)) And (Label1(Index).Top = MemTop - (Label1(Index).Height * 2))) Or _
     ((Label1(Index).Left = MemLeft - (Label1(Index).Width * 2)) And (Label1(Index).Top = MemTop + (Label1(Index).Height))) Or _
     ((Label1(Index).Left = MemLeft - (Label1(Index).Width)) And (Label1(Index).Top = MemTop + (Label1(Index).Height * 2))) Or _
     ((Label1(Index).Left = MemLeft - (Label1(Index).Width * 2)) And (Label1(Index).Top = MemTop - (Label1(Index).Height))) Or _
     ((Label1(Index).Left = MemLeft - (Label1(Index).Width)) And (Label1(Index).Top = MemTop - (Label1(Index).Height * 2))) Then

        'get picture over clicked label
        Image1.Top = Label1(Index).Top
        Image1.Left = Label1(Index).Left
        '& change it's color to....
        Label1(Index).BackColor = QBColor(0) 'black
        'remember position
        MemTop = Label1(Index).Top
        MemLeft = Label1(Index).Left
        'for use with redo and undo
        List3.AddItem (Index)
  End If
End If
End Sub

Private Sub Mix(Hdim As Integer, Wdim As Integer)
Label1(0).Enabled = False

Hdim1 = Hdim
Wdim1 = Wdim
'not true as game ain't set jet

FirstClick = False
Image1.Visible = False
List3.Clear


'clear all previously made controls
For i = 1 To Label1.UBound
Unload Label1(i)
Next i

Label1(0).BackColor = &HFF&
DoEvents
Dim MyArray() As Integer
On Error GoTo errorhandler


ReDim MyArray(Hdim, Wdim)
z = 0
'Load numerous labels
For j = 1 To Wdim
    For i = 1 To Hdim
    z = z + 1
    Load Label1(z)
    MyArray(i, j) = z
    Label1(z).Left = (i * Label1(0).Width) - Label1(0).Width
    Label1(z).Top = j * Label1(z).Height - Label1(0).Height
    'Label1(z).Caption = MyArray(i, j)
    Label1(z).Caption = ""
    Label1(z).Enabled = False
    Label1(z).Visible = True
    Next i
Next j

'get randome start point inside array
Randomize
iRnd = Int(Rnd * UBound(MyArray, 1))
jRnd = Int(Rnd * UBound(MyArray, 2))

'show our randome pick
Label1(MyArray(iRnd, jRnd)).BackColor = QBColor(9)



'now the main thinking about mixing
'each label have 8 posible next positions
'unles they are out of scope or allready busy

' lets get values on base of which we will check out colors of
' loaded labels
Dim DC(1, 7) As Integer 'Fixed DataContainer Array
Dim DC1(1, 7) As Integer 'Fixed DataContainer Array

 

DoEvents

Do
   DC(0, 0) = 2: List1.AddItem (2)
    DC(1, 0) = 1: List2.AddItem (1)
    DC(0, 1) = 1: List1.AddItem (1)
    DC(1, 1) = 2: List2.AddItem (2)
    DC(0, 2) = 2: List1.AddItem (2)
    DC(1, 2) = -1: List2.AddItem (-1)
    DC(0, 3) = 1: List1.AddItem (1)
    DC(1, 3) = -2: List2.AddItem (-2)
    DC(0, 4) = -1: List1.AddItem (-1)
    DC(1, 4) = -2: List2.AddItem (-2)
    DC(0, 5) = -2: List1.AddItem (-2)
    DC(1, 5) = -1: List2.AddItem (-1)
    DC(0, 6) = -2: List1.AddItem (-2)
    DC(1, 6) = 1: List2.AddItem (1)
    DC(0, 7) = -1: List1.AddItem (-1)
    DC(1, 7) = 2: List2.AddItem (2)
'Mix positions of DC into DC1 randomly
 g = List1.ListCount
   For t = 0 To g
  df = Int(Rnd * List1.ListCount)
  DC1(0, t) = List1.List(df)
  DC1(1, t) = List2.List(df)
  List1.RemoveItem (df)
  List2.RemoveItem (df)
  Next t
'Beep


'do the mixing.................
For r = 0 To UBound(DC1, 2)

    If Label1(MyArray(iRnd + DC1(0, r), jRnd + DC1(1, r))).BackColor <> QBColor(9) Then
    Label1(MyArray(iRnd + DC1(0, r), jRnd + DC1(1, r))).BackColor = QBColor(9)
    
        If SubscriptOutOfRange = True Then
        SubscriptOutOfRange = False
        GoTo 11
        End If
    
    iRnd = iRnd + DC1(0, r)
    jRnd = jRnd + DC1(1, r)
    found = True
    Exit For
    End If
11
Next r


DoEvents
If found = False Then
'end of mixing
  For i = 0 To Label1.UBound
  Label1(i).Enabled = True
  Next i
  DoEvents


Exit Sub
End If
found = False

'for testing purpose
'For t = 0 To 1200000
'Next t


Loop





Exit Sub
errorhandler:
Select Case Err
Case 9
SubscriptOutOfRange = True

Case Else
End Select
Resume Next

End Sub

Private Sub Prodigy_Click()
Dim a As Integer
Dim b As Integer

'Me.Width = Screen.Width
'Me.Height = Screen.Height
 
Me.WindowState = 2

Image1.Width = 16
Image1.Height = 16

Label1(0).Width = 16
Label1(0).Height = 16

a = Int(Me.ScaleHeight / 16)
b = Int(Me.ScaleWidth / 16)

Call Mix(b, a)


 
End Sub
